% Copyright (C) 2008-2011 - Consortium Scilab - Digiteo - Michael Baudin
%
% This file must be used under the terms of the 
% Creative Commons Attribution-ShareAlike 3.0 Unported License :
% http://creativecommons.org/licenses/by-sa/3.0/


\section{Introduction}

In numerical analysis, a sparse matrix is a matrix 
populated primarily with zeros\cite{wiki:sparsematrix}.
Huge sparse matrices often appear in science or engineering when solving 
partial differential equations.

Scilab provides several features to manage sparse matrices and 
perform usual linear algebra operations on them. 
These operations includes all the basic linear algebra including addition, 
dot product, transpose and the matrix vector product. 
For these basic operations, we do not make any difference in a 
script managing a dense matrix and a script managing a sparse matrix.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection{Note on this document}

This document is an open-source project. 
The \LaTeX{} sources are available on the Scilab Forge:
\begin{center}
\url{http://forge.scilab.org/index.php/p/docscisparse/}
\end{center}
The \LaTeX{} sources are provided under the terms of the 
Creative Commons Attribution-ShareAlike 3.0 Unported License:
\begin{center}
\url{http://creativecommons.org/licenses/by-sa/3.0}
\end{center}
The Scilab scripts are provided on the Forge, inside the project, under 
the \verb|scripts| sub-directory.
The scripts are available under the CeCiLL licence:
\begin{center}
\url{http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt}
\end{center}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{Overview}

In this section, we make an overview of the features provided 
by Scilab for sparse matrices.

The current set of tools available in Scilab for sparse matrices are the 
following:
\begin{itemize}
\item management of sparse matrices of arbitrary size,
\item basic algebra on sparse matrices, including, sum, dot product, 
   transpose, matrix-matrix product,
\item sparse LU decomposition and resolution of linear equations from this 
   decomposition based on the Sparse package written by Kenneth S. Kundert 
   and Alberto Sangiovanni-Vincentelli,
\item sparse Cholesky decomposition and resolution of linear equations from this 
   decomposition, based on a sparse Cholesky factorization package developed 
   by Esmond Ng and Barry Peyton at ORNL and a multiple minimun-degree 
   ordering package by Joseph Liu at University of Waterloo,
\item iterative methods of linear systems of equations, including Preconditionned 
   Conjugate Gradient (pcg), Generalized Minimum Residual method (gmres), 
   Quasi Minimal Residual method with preconditionning (qmr),
\item sparse LU decomposition and resolution of linear equations from this 
   decomposition based on the UMFPACK library,
\item sparse Cholesky decomposition and resolution of linear equations from this 
   decomposition based on the TAUCS library,
\item sparse eigenvalue computations, based on the Arpack library, 
   using the Implicitly Restarted Arnoldi Method.
\end{itemize}

Scilab manages several file formats read and write sparse matrices. 
\begin{itemize}
\item Scilab is able to read matrices in the Harwell-Boeing format, thanks to the 
ReadHBSparse function of the Umfpack module.
\item The Matrix Market external module (available in ATOMS) provides functions to read 
and write matrices in the Matrix Market format. 
\end{itemize}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\section{Basic features}

In this section, we present the basic sparse matrix features. 
In the first part, we review how to create a sparse matrix. 
Then we analyze how a sparse matrix is stored internally. 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection{Creating sparse matrices}

The figure \ref{fig-scisparse-basic} present several functions 
to create sparse matrices.

\begin{figure}
\begin{center}
\begin{tabular}{|ll|}
\hline
sp2adj & converts sparse matrix into adjacency form \\
speye & sparse identity matrix \\
spones & sparse matrix \\
sprand & sparse random matrix \\
spzeros & sparse zero matrix \\
\hline
full & sparse to full matrix conversion \\
sparse & sparse matrix definition \\
mtlb\_sparse & convert sparse matrix \\
nnz & number of non zero entries in a matrix \\
spcompack & converts a compressed adjacency representation \\
spget & retrieves entries of sparse matrix \\
\hline
\end{tabular}
\end{center}
\caption{Basic features for sparse matrices.}
\label{fig-scisparse-basic}
\end{figure}

In the following session, we use the \scifun{sprand} function 
to create a $100\times 1000$ 
sparse matrix with density 0.001. The density parameter
makes so that the number of non-zero entries in the 
sparse matrix is approximately equal to $100\cdot 1000\cdot 0.001=100$.
Then we use the \scifun{size} function to compute the size of the 
matrix. Finally, we compute the number of non-zero entries with the \scifun{nnz}
function.
\lstset{language=scilabscript}
\begin{lstlisting}
-->A=sprand(100,1000,0.001);
-->size(A)
 ans  =
    100.    1000. 
-->nnz(A)
 ans  =
    100.  
\end{lstlisting}

The \scifun{sparse} and \scifun{full} functions works as complementary
functions. Indeed, the \scifun{sparse} function converts a full matrix into a 
sparse one, while the \scifun{full} function converts a sparse matrix 
into a full one.

In the following session, we create a $3\times 5$ dense matrix.
Then we use the \scifun{sparse} function to convert it into a sparse matrix.
Scilab then displays all the non-zero entries of the matrix one at a time.
Finally, we use the \scifun{full} function to convert the sparse matrix 
into a dense one.
\lstset{language=scilabscript}
\begin{lstlisting}
-->A = [
-->1 2 0 0 0
-->3 4 5 0 0
-->0 6 7 8 0
-->]
 A  =
    1.    2.    0.    0.    0.  
    3.    4.    5.    0.    0.  
    0.    6.    7.    8.    0.  
-->B = sparse(A)
 B  =
(    3,    5) sparse matrix
(    1,    1)        1. 
(    1,    2)        2. 
(    2,    1)        3. 
(    2,    2)        4. 
(    2,    3)        5. 
(    3,    2)        6. 
(    3,    3)        7. 
(    3,    4)        8. 
-->C = full(B)
 C  =
    1.    2.    0.    0.    0.  
    3.    4.    5.    0.    0.  
    0.    6.    7.    8.    0.  
\end{lstlisting}

Sparse matrices can be real or complex. 
In the following session, we define a 3-by-5 complex matrix 
of doubles.
\lstset{language=scilabscript}
\begin{lstlisting}
-->A = [
-->1 2 0 0 0
-->3 4 5 0 0
-->0 6 7 8 0
-->];
-->B = [
-->9  10  0  0 0
-->11 12 13  0 0
-->0  14 15 16 0
-->];
-->C=complex(A,B)
 C  =
  1. + 9.i    2. + 10.i   0           0           0
  3. + 11.i   4. + 12.i   5. + 13.i   0           0
  0           6. + 14.i   7. + 15.i   8. + 16.i   0
-->D=sparse(C)
 D  =
(    3,    5) sparse matrix
(    1,    1)       1. + 9.i 
(    1,    2)       2. + 10.i 
(    2,    1)       3. + 11.i 
(    2,    2)       4. + 12.i 
(    2,    3)       5. + 13.i 
(    3,    2)       6. + 14.i 
(    3,    3)       7. + 15.i 
(    3,    4)       8. + 16.i 
\end{lstlisting}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection{Storage format}
\label{section-storageformat}

There are various ways of storing the nonzero entries of a sparse matrix. 
In this section, we review how sparse matrices are stored internally, 
at the library level. 

As we are going to see, the format used in Scilab is very similar (but not 
exactly identical) to the compressed sparse 
row format (CSR), in which the nonzero entries are stored row-by-row. 
While this detail does not change the way a user user sparse matrices at the 
interpreter level, it does have an impact on the way the libraries are 
connected to Scilab. 
Hence, this is an important feature of sparse matrices in Scilab and it is 
worthwhile to know precisely what is stored. 

In Scilab, a sparse matrix is defined in the \csource{modules/core/includes/sparse.h}. 
This is a C \csource{struct} with type \csource{scisparse} and the following fields:
\begin{itemize}
\item \csource{int m}: the number of rows.
\item \csource{int n}: the number of columns.
\item \csource{int it}: is equal to 0 if the matrix is real, and 1 if the matrix is complex.
\item \csource{int nel}: number of nonzero elements */
\item \csource{int *mnel}: an array with \csource{m} entries. The entry \csource{mnel[i]} is 
the number of non nul elements of the i-th row.
\item \csource{int *icol}: an array with \csource{nel} entries. 
The entry \csource{icol[j]} is the column of the j-th nonzero element.
\item \csource{double *R}: an array with \csource{nel} entries. 
The entry \csource{R[j]} is the real part of the j-th nonzero element.
\item \csource{double *I}: an array with \csource{nel} entries. 
The entry \csource{I[j]} is the imaginary part of the j-th nonzero element.
\end{itemize}

Consider the sparse matrix in the following example.
\lstset{language=scilabscript}
\begin{lstlisting}
-->A = [
-->1 2 0
-->3 4 5
-->0 6 7
-->];
-->B = sparse(A);
\end{lstlisting}
In this case, the fields are the following.
\lstset{language=scilabscript}
\begin{lstlisting}
B.m: 3
B.n: 3
B.it: 0
B.nel: 7
B.mnel: [2, 3, 2]
B.icol: [1, 2, 1, 2, 3, 2, 3]
B.R: [1.0, 2.0, 3.0, 4.0, 5.0, 6.0, 7.0]
B.I: [undefined]
\end{lstlisting}

This current storage is different from the CSR format, in the sense that 
there is no array containing the row indices corresponding to the values and 
no array containing the cumulated indexes where each column starts.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{Sparse arithmetic}

Scilab provides arithmetic operators for sparse matrices.

Indeed, most operators are defined for sparse matrices. 
For example, the operators \scivar{+}, \scivar{-} and \scivar{*}  
can be used for sparse matrices, as shown in the following example.
\lstset{language=scilabscript}
\begin{lstlisting}
Afull= [
  2  3  0  0  0;
  3  0  4  0  6; 
  0 -1 -3  2  0; 
  0  0  1  0  0; 
  0  4  2  0  1
];
A = sparse(Afull);
B = 2*A
C = A+B
x = [1;2;3;4;5]
b = A * x
\end{lstlisting}

Another operator is the backslash operator \scivar{\textbackslash}, which is presented in the 
next section.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\section{Solving sparse linear equations}

Scilab provide direct and iterative methods to solve linear systems 
of equations. The figure \ref{fig-scisparse-sparsemodule} presents these 
methods.

\begin{figure}
\begin{center}
\begin{tabular}{|ll|}
\hline
lufact & sparse lu factorization \\
lusolve & sparse linear system solver \\
luget & extraction of sparse LU factors \\
ludel & utility function used with lufact \\
\hline
chfact & sparse Cholesky factorization \\
chsolve & sparse Cholesky solver \\
\hline
spchol & sparse Cholesky factorization \\
\hline
gmres & Generalized Minimum RESidual method \\
pcg & precondioned conjugate gradient \\
qmr & quasi minimal resiqual method with preconditioning \\
\hline
\end{tabular}
\end{center}
\caption{Direct and iterative functions to solve sparse linear equations.}
\label{fig-scisparse-sparsemodule}
\end{figure}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{Sparse LU decomposition}

The sparse LU decomposition available in Scilab is based on the 
Sparse package written by Kenneth S. Kundert and Alberto Sangiovanni-Vincentelli \cite{Kundert-86}.
This package is available in Netlib \cite{sparseNetlib}.

Sparse is a flexible package of subroutines written in C used to quickly 
and accurately solve large sparse systems of linear equations. The 
package is able to handle arbitrary real and complex square matrix 
equations. Besides being able to solve linear systems, it is also able 
to quickly solve transposed systems, find determinants, and estimate 
errors due to ill-conditioning in the system of equations and 
instability in the computations. Sparse also provides a test program 
that is able read matrix equations from a file, solve them, and print 
useful information about the equation and its solution.

Sparse is generally as fast or faster than other popular sparse matrix
packages when solving many matrices of similar structure. Sparse does 
not require or assume sym- metry and is able to perform numerical 
pivoting to avoid unnecessary error in the solution. It handles its own 
memory allocation, which allows the user to forgo the hassle of 
providing adequate memory. It also has a natural, flexi- ble, and 
efficient interface to the calling program.

Sparse was originally written for use in circuit simu- lators and is
particularly apt at handling node- and modified-node admittance 
matrices. The systems of linear generated in a circuit simulator stem 
from solving large systems of nonlinear equations using Newton's method 
and integrating large stiff systems of ordinary differential equations. 
However, Sparse is also suitable for other uses, one in particular is 
solving the very large systems of linear equations resulting from the 
numerical solution of partial differential equations.

The \scifun{lufact}, \scifun{lusolve}, \scifun{luget} and \scifun{ludel} 
functions is a set of functions providing a sparse direct method to 
solve linear systems of equations. As their names suggest it, they use a sparse 
LU decomposition to compute the solution. 

In the following script, we define a sparse matrix \scivar{spA} with entries $(1,2,3,4)$ on the diagonal only.
Then we use the \scifun{lufact} function to compute the LU decomposition of the 
matrix \scivar{spA}. The output of the \scifun{lufact} function are a handle 
to the factors \scivar{h} and the rank \scivar{rk} of the matrix. The variable  
\scivar{h} has no direct use for the user. In fact, it represents a memory location
where Scilab has stored the actual factors. The purpose of the variable \scivar{h}
is to be an input argument of the \scifun{lusolve}, \scifun{luget} and \scifun{ludel} 
functions. In the script, we pass \scivar{h} and the right hand-side \scivar{b} to the 
\scifun{lusolve} function, which produces the solution \scivar{x} of the equation $Ax=b$.
Finally, we delete the LU factors with the \scifun{ludel} function.
\lstset{language=scilabscript}
\begin{lstlisting}
non_zeros=[1,2,3,4];
rows_cols=[1,1;2,2;3,3;4,4];
spA = sparse(rows_cols,non_zeros)
[h,rk] = lufact(sp);
b = [1 1 1 1]';
x=lusolve(h,b)
ludel(h);
\end{lstlisting}
The previous script produces the following output.
\lstset{language=scilabscript}
\begin{lstlisting}
-->non_zeros=[1,2,3,4];
-->rows_cols=[1,1;2,2;3,3;4,4];
-->spA = sparse(rows_cols,non_zeros)
 spA  =
(    4,    4) sparse matrix
(    1,    1)        1. 
(    2,    2)        2. 
(    3,    3)        3. 
(    4,    4)        4. 
-->[h,rk] = lufact(sp);
-->b = [1 1 1 1]';
-->x=lusolve(h,b)
 x  =
    1.         
    0.5        
    0.3333333  
    0.25       
-->ludel(h);
\end{lstlisting}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{Sparse backslash}

The backslash operator \scivar{\textbackslash} can be used with sparse 
matrices. 
Depending on the size of the sparse matrix \scivar{A}, 
the statement \scivar{A\textbackslash b} has two different meanings.
\begin{itemize}
\item If the matrix \scivar{A} is square, therefore the 
linear system of equations $Ax=b$ is solved. 
In this case, the sparse backslash uses a sparse LU decomposition 
to solve the problem. 
\item If the matrix \scivar{A} is non square, therefore the 
linear least squares problem $\min \|Ax-b\|_2$ is solved.
In this case, the sparse backslash uses the normal equations and 
form the linear system of equations $A^T Ax = A^Tb$. 
Then a sparse LU decomposition is used to solve the problem. 
\end{itemize}

In the following example, we solve a sparse 5-by-5 system of linear 
equations.
\lstset{language=scilabscript}
\begin{lstlisting}
Afull= [
  2  3  0  0  0;
  3  0  4  0  6; 
  0 -1 -3  2  0; 
  0  0  1  0  0; 
  0  4  2  0  1
];
A = sparse(Afull);
b = sparse([8 ; 45; -3; 3; 19]);
x = A\b
\end{lstlisting}

In the following example, we solve a 7-by-5 overdetermined system of 
equations.
\lstset{language=scilabscript}
\begin{lstlisting}
Afull= [
  2  3  0  0  0
  3  0  4  0  6 
  0 -1 -3  2  0 
  0  0  1  0  0 
  0  4  2  0  1
  2 -5  0 -6  3
  2  0 -5 -6  3
];
A = sparse(Afull);
b = [8 ; 45; -3; 3; 19; -5; 8];
x = A\b
norm(A*x-b)
\end{lstlisting}
The previous script produces the following output.
\lstset{language=scilabscript}
\begin{lstlisting}
-->x = A\b
 x  =
  - 0.3094732  
    2.9663371  
    0.7519368  
    1.6123139  
    7.0851981  
-->norm(A*x-b)
 ans  =
    3.2147514  
\end{lstlisting}

The sparse backslash operator \scivar{\textbackslash} is based on the 
\scifun{lufact} and \scifun{lusolve} functions. 
It is implemented with overloading. 
For example, the \scifun{\%sp\_l\_sp} function provides the 
operation \scivar{A\textbackslash b}, where both \scivar{A} and \scivar{b} are 
sparse.

The sparse backslash in Scilab v5.3.2 has a major drawback: 
it does not manage sparse triangular matrices \cite{sparseBackslashTriangular2011}. 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{Iterative methods for sparse linear equations}

The \scifun{pcg} function is a precondioned conjugate gradient algorithm
for symmetric positive definite matrices.
It can managed dense or sparse matrices, but is mainly designed for large 
sparse systems of linear equations. It is based on a Scilab port of the 
Matlab scripts provided in \cite{templates1994}.

In the following example, we define a dense, well-conditionned $10\times 10$ dense matrix $A$ and a 
right hand size $b$ made of ones.
We use the \scifun{sparse} function to convert the \scivar{A} matrix into the sparse matrix 
\scivar{Asparse}.
We finally use the \scifun{pcg} function on the sparse matrix \scivar{Asparse} in order to solve 
the equations $Ax=b$. This produces the solution \scivar{x}, a status flag \scivar{fail}, the 
relative residual norm \scivar{err}, the number of iterations \scivar{iter} and the 
vector of the residual relative norms \scivar{res}.
\lstset{language=scilabscript}
\begin{lstlisting}
A=[ 94  0   0   0    0   28  0   0   32  0  
     0   59  13  5    0   0   0   10  0   0  
     0   13  72  34   2   0   0   0   0   65 
     0   5   34  114  0   0   0   0   0   55 
     0   0   2   0    70  0   28  32  12  0  
     28  0   0   0    0   87  20  0   33  0  
     0   0   0   0    28  20  71  39  0   0  
     0   10  0   0    32  0   39  46  8   0  
     32  0   0   0    12  33  0   8   82  11 
     0   0   65  55   0   0   0   0   11  100];
b=ones(10,1);
Asparse=sparse(A);
[x, fail, err, iter, res]=..
    pcg(Asparse,b,maxIter=30,tol=1d-12)
\end{lstlisting}
The previous script produces the following output.
\lstset{language=scilabscript}
\begin{lstlisting}
-->[x, fail, err, iter, res]=..
-->    pcg(Asparse,b,maxIter=30,tol=1d-12)
 res  =
    1.         
    0.2302743  
    0.1102172  
    0.0223463  
    0.0096446  
    0.0052038  
    0.0037525  
    0.0006959  
    0.0000207  
    0.0000042  
    1.697D-13  
 iter  =
    10.  
 err  =
    1.697D-13  
 fail  =
    0.  
 x  =
    0.0071751  
    0.0134492  
    0.0067610  
    0.0050339  
    0.0073735  
    0.0065248  
    0.0042064  
    0.0093434  
    0.0044640  
    0.0023456  
\end{lstlisting}
We see that 10 iterations were required to get a residual close to $10^{-13}$. 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\section{Cholesky factorizations}

In this section, we review the \scifun{chfact} and \scifun{spchol} functions, 
which both perform sparse Cholesky decomposition.


The figure \ref{fig-scisparse-cholesky} presents the functions which 
allow to compute the Cholesky decomposition of sparse matrices.

\begin{figure}
\begin{center}
\begin{tabular}{|ll|}
\hline
chfact & sparse Cholesky factorization \\
chsolve & sparse Cholesky solver \\
\hline
spchol & sparse cholesky factorization with permutations\\
\hline
\end{tabular}
\end{center}
\caption{Cholesky factorizations for sparse matrices.}
\label{fig-scisparse-cholesky}
\end{figure}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{The \scifun{chfact} and \scifun{chsolve} functions}

The \scifun{chfact} and \scifun{chsolve} functions can be combined 
in order to solve sparse linear systems of equations, if the matrix is 
symmetric positive definite. 
In the following example, we solve the equation $Ax=b$ where 
$A$ is a sparse 5-by-5 symmetric definite positive matrix.
\lstset{language=scilabscript}
\begin{lstlisting}
Afull= [ 
    2 -1  0  0  0;
    -1  2 -1  0  0; 
    0 -1  2 -1  0; 
    0  0 -1  2 -1; 
    0  0  0 -1  2
];
A = sparse(Afull);
h = chfact(A);
b = [0 ; 0; 0; 0; 6];
chsolve(h,b)
\end{lstlisting}

In the previous script, the variable \scivar{h} is a complex 
data structure which contains the Cholesky decomposition. 
This decomposition makes use of a minimal degree algorithm, which 
reduces the fill-in in the Cholesky factors. 
Hence, the Cholesky decomposition makes implicitely use 
of a permutation matrix $P$, such that $P'AP$ can be more 
efficiently factored than $A$. 

The previous script produces the following output.
\lstset{language=scilabscript}
\begin{lstlisting}
-->chsolve(h,b)
 ans  =
    1.  
    2.  
    3.  
    4.  
    5.  
\end{lstlisting}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{The \scifun{spchol} function}


The \scifun{[L,P]=spchol(X)} statement produces a sparse lower triangular matrix $L$ 
and a sparse permutation matrix $P$ such that $P L L^T P^T=X$.
In the following script, we use the \scifun{spchol} function to compute the 
sparse Cholesky decomposition of a symmetric definite positive matrix.
\lstset{language=scilabscript}
\begin{lstlisting}
-->Afull= [ 
-->    2 -1  0  0  0;
-->    -1  2 -1  0  0; 
-->    0 -1  2 -1  0; 
-->    0  0 -1  2 -1; 
-->    0  0  0 -1  2
-->];
-->A = sparse(Afull);
[L,P]=spchol(A)
\end{lstlisting}
The previous script produces the following output.
\lstset{language=scilabscript}
\begin{lstlisting}
-->[L,P]=spchol(A)
 P  =
(    5,    5) sparse matrix
(    1,    3)        1. 
(    2,    4)        1. 
(    3,    5)        1. 
(    4,    2)        1. 
(    5,    1)        1. 
 L  =
(    5,    5) sparse matrix
(    1,    1)        1.4142136 
(    2,    1)      - 0.7071068 
(    2,    2)        1.2247449 
(    3,    3)        1.4142136 
(    4,    3)      - 0.7071068 
(    4,    4)        1.2247449 
(    5,    2)      - 0.8164966 
(    5,    4)      - 0.8164966 
(    5,    5)        0.8164966 
\end{lstlisting}
The \scifun{spchol} function \cite{ScolaLipsol1997} 
uses two Fortran packages: a sparse Cholesky factorization package
developed by Esmond Ng and Barry Peyton at ORNL and a multiple
minimun-degree ordering package by Joseph Liu at University of Waterloo.

The \scifun{spchol} function can be used to solve linear systems of 
equations. 
Indeed, assume that $A$ is a sparse n-by-n real symmetric matrix and 
that $b$ is a n-by-1 vector. 
We may want to solve the system of equations
\begin{eqnarray}
Ax=b
\end{eqnarray}
for $x$. 
Assume that the matrix $A$ can be decomposed into:
\begin{eqnarray}
A = P L L^T P^T,
\end{eqnarray}
where $L$ is an n-by-n lower triangular real matrix and 
$P$ is an n-by-n permutation matrix. 
The product $P^T P$ is the identity matrix, which implies:
\begin{eqnarray}
 (AP) (P^T x) = b
\end{eqnarray}
We left multiply this equation by $P^T$ and get :
\begin{eqnarray}
 (P^T A P) (P^T x) = P^T b
\end{eqnarray}
Hence
\begin{eqnarray}
 (P^T P L L^T P^T P) (P^T x) = P^T b
\end{eqnarray}
which simplifies into
\begin{eqnarray}
 (L L^T) (P^T x) = P^T b.
\end{eqnarray}
In order to solve this equation, we first solve the equation 
\begin{eqnarray}
 (L L^T) y = P^T b
\end{eqnarray}
 where 
\begin{eqnarray}
 y = P^T x.
\end{eqnarray}
In the Scilab language, the solution is 
\lstset{language=scilabscript}
\begin{lstlisting}
 y = L'\(L\P'*b)
\end{lstlisting}
Moreover, \scivar{x=P*y}, which implies
\lstset{language=scilabscript}
\begin{lstlisting}
 x = P*(L'\(L\(P'*b)))
\end{lstlisting}

In the following script, we use the \scifun{spchol} function to solve 
a symmetric sparse linear system of equations. 
\lstset{language=scilabscript}
\begin{lstlisting}
Afull= [ 
    2 -1  0  0  0;
    -1  2 -1  0  0; 
    0 -1  2 -1  0; 
    0  0 -1  2 -1; 
    0  0  0 -1  2
];
A = sparse(Afull);
[L,P] = spchol(A);
n = size(A,"r");
e = (1:n)';
b = A * e;
x = P*(L'\(L\(P'*b)))
\end{lstlisting}
The previous script produces the following output.
\lstset{language=scilabscript}
\begin{lstlisting}
-->x = P*(L'\(L\(P'*b)))
 x  =
    1.  
    2.  
    3.  
    4.  
    5.  
\end{lstlisting}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{Conclusion}

The \scifun{spchol} and \scifun{chfact} actually use the same algorithms. 
The method is based on the minimum degree algorithm, which produces a 
permutation matrix $P$ which reduces the amount of fill-in in 
the Cholesky factors. 
The \scifun{chsolve} function may be considered as unnecessary, since 
the sparse backslash operator is designed for the same purpose. 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\section{Functions from the UMFPACK module}

The UMFPACK module provide several functions related to sparse matrices. 
These functions are presented in the figure figure \ref{fig-scisparse-umfpackfuns}.

\begin{figure}
\begin{center}
\begin{tabular}{|ll|}
\hline
PlotSparse & plot the pattern of non nul elements of a sparse matrix \\
ReadHBSparse & read a Harwell-Boeing sparse format file \\
cond2sp & computes an approximation of the 2-norm condition \\
        & number of a s.p.d. sparse matrix \\
condestsp & estimate the condition number of a sparse matrix \\
rafiter & (obsolete) iterative refinement for a s.p.d. linear system \\
res\_with\_prec & computes the residual r = Ax-b with precision \\
\hline
\end{tabular}
\end{center}
\caption{Functions from the umfpack module.}
\label{fig-scisparse-umfpackfuns}
\end{figure}

In the following script, we read a sparse matrix provided in the Umfpack module 
with the \scivar{ReadHBSparse} function. 
Then we plot the sparsity pattern with the \scifun{PlotSparse} function. 
\lstset{language=scilabscript}
\begin{lstlisting}
umfdir = fullfile(SCI,"modules","umfpack","examples");
filename = fullfile(umfdir,"arc130.rua");
A = ReadHBSparse(filename);
PlotSparse(A,"y+");
\end{lstlisting}
The previous script produces the figure \ref{fig-plotSparse}.

\begin{figure}
\begin{center}
\includegraphics[width=10cm]{sparse-matrixPlot}
\end{center}
\caption{Sparsity pattern of the arc130 matrix.}
\label{fig-plotSparse}
\end{figure}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\section{The UMFPACK package}

The UMFPACK package provide several direct algorithms to compute 
LU decompositions of sparse matrices. 
The algorithms also solve sparse linear systems of equations, that is, they solve the 
equation $Ax=b$, where $A$ is a sparse squares matrix and $b$ is a sparse 
vector. 
These functions are presented in the figure \ref{fig-scisparse-umfpack}.

\begin{figure}
\begin{center}
\begin{tabular}{|ll|}
\hline
umf\_license & display the umfpack license \\
umf\_ludel & utility function used with umf\_lufact \\
umf\_lufact & lu factorisation of a sparse matrix \\
umf\_luget & retrieve lu factors at the scilab level \\
umf\_luinfo & get information on LU factors \\
umf\_lusolve & solve a linear sparse system given the LU factors \\
umfpack & solve sparse linear system \\
\hline
\end{tabular}
\end{center}
\caption{Functions from the umfpack module.}
\label{fig-scisparse-umfpack}
\end{figure}

The following example shows how to combine the \scifun{umf\_lufact} function 
with the \scifun{umf\_lusolve} function in order to solve the linear 
system of equations $Ax=b$.
\lstset{language=scilabscript}
\begin{lstlisting}
Afull= [
  2  3  0  0  0;
  3  0  4  0  6; 
  0 -1 -3  2  0; 
  0  0  1  0  0; 
  0  4  2  0  1
];
A = sparse(Afull)
b = [8 ; 45; -3; 3; 19];
h = umf_lufact(A);
x = umf_lusolve(h,b)
umf_ludel(h);
\end{lstlisting}
The previous script produces the following output.
\lstset{language=scilabscript}
\begin{lstlisting}
-->x = umf_lusolve(h,b)
 x  =
    1.  
    2.  
    3.  
    4.  
    5.  
\end{lstlisting}

In the previous script, the variable \scivar{h} is a matrix handle, 
which contains informations related to the sparse matrix. 
This is why it is necessary to explicitely delete the 
matrix with the \scifun{umf\_ludel} function. 
Indeed, if we do not delete the matrix handle, there is a loss of 
memory.

The Umfpack library was developped by Timothy Davis \cite{SparseUmfpack}, 
from the University of Florida. 
His package is distributed under the GNU GPL license.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\section{The TAUCS package}

The TAUCS package provide several direct algorithms to compute 
Cholesky decompositions of sparse matrices. 
This package only manage symmetric positive definite matrices. 
The algorithms also solve sparse linear systems of equations, that is, they solve the 
equation $Ax=b$, where $A$ is a sparse squares matrix and $b$ is a sparse 
vector. 

The TAUCS package is available in the UMFPACK module. 
The functions provided in the TAUCS package are presented 
in the figure \ref{fig-scisparse-taucs}.

\begin{figure}
\begin{center}
\begin{tabular}{|ll|}
\hline
taucs\_chdel & utility function used with taucs\_chfact \\
taucs\_chfact & cholesky factorisation of a sparse s.p.d. matrix \\
taucs\_chget & retrieve the Cholesky factorization at the scilab level \\
taucs\_chinfo & get information on Cholesky factors \\
taucs\_chsolve & solve a linear sparse system given the Cholesky factors \\
taucs\_license & display the taucs license \\
\hline
\end{tabular}
\end{center}
\caption{Functions from the TAUCS module.}
\label{fig-scisparse-taucs}
\end{figure}

In the following example, we factor a sparse matrix and solve 
the associated linear system of equations. 
Notice that the matrix \scivar{A} is symmetric positive definite. 
\lstset{language=scilabscript}
\begin{lstlisting}
Afull= [ 
    2 -1  0  0  0;
    -1  2 -1  0  0; 
    0 -1  2 -1  0; 
    0  0 -1  2 -1; 
    0  0  0 -1  2
];
A = sparse(Afull);
b = [0 ; 0; 0; 0; 6];
h = taucs_chfact(A);
x = taucs_chsolve(h,b)
taucs_chdel(h);
\end{lstlisting}

In the previous script, the variable \scivar{h} is a matrix handle, 
which contains informations related to the sparse matrix. 
This is why it is necessary to explicitely delete the 
matrix with the \scifun{taucs\_chdel} function. 
Indeed, if we do not delete the matrix handle, there is a loss of 
memory.

The TAUCS library was developed by Sivan Toledo from Tel-Aviv University \cite{TaucsLibWWW}.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{The API}

Scilab provides an API to manage sparse matrices. 
The figure \ref{fig-scisparse-sciapi} presents the functions  
to read or write sparse matrices in gateways. 
The figure \ref{fig-scisparse-sciapiLists} presents the functions to read 
or write sparse matrices in lists.

\begin{figure}
\begin{small}
\begin{center}
\begin{tabular}{|ll|}
\hline
\multicolumn{2}{|l|}{Read sparse doubles matrices in gateways} \\
\hline
getSparseMatrix &  R. a sp. mat. \\
getComplexSparseMatrix &  R. a complex sp. mat. \\
readNamedSparseMatrix &  R. a named sp. mat. \\
readNamedComplexSparseMatrix &  R. a named complex sp. mat. \\
\hline
\hline
\multicolumn{2}{|l|}{Write sparse doubles matrices in gateways} \\
\hline
createSparseMatrix &  W. a sp. mat. \\
createComplexSparseMatrix &  W. a complex sp. mat. \\
createNamedSparseMatrix &  W. a named sp. mat. \\
createNamedComplexSparseMatrix &  W. a named complex sp. mat. \\
\hline
\multicolumn{2}{|l|}{Read/Write sparse boolean matrices in gateways} \\
\hline
getBooleanSparseMatrix & R. a boolean sp. mat. \\
readNamedBooleanSparseMatrix & R. a named boolean sp. mat. \\
createBooleanSparseMatrix & W. a boolean sp. mat. \\
createNamedBooleanSparseMatrix & W. a named boolean sp. mat. \\
\hline
\end{tabular}
\end{center}
\caption{The sparse API, to be used in gateways.}
\label{fig-scisparse-sciapi}
\end{small}
\end{figure}

\begin{figure}
\begin{small}
\begin{center}
\begin{tabular}{|l|}
\hline
Read sparse matrices in a list \\
\hline
getSparseMatrixInList \\
\hspace{1cm} R. a sp. mat. of doubles in a list. \\
getComplexSparseMatrixInList  \\
\hspace{1cm} R. a sp. mat. of complex doubles in a list. \\
readSparseMatrixInNamedList  \\
\hspace{1cm} R. a named sp. mat. of doubles in a list. \\
readComplexSparseMatrixInNamedList  \\
\hspace{1cm} R. a named sp. mat. of complex doubles in a list. \\
\hline
\hline
Write sparse matrices in lists \\
\hline
createSparseMatrixInList  \\
\hspace{1cm} W. a sp. mat. of doubles in a list. \\
createComplexSparseMatrixInList  \\
\hspace{1cm} W. a sp. mat. of complex doubles in a list. \\
createSparseMatrixInNamedList  \\
\hspace{1cm} W. a sp. mat. of doubles in a named list. \\
createComplexSparseMatrixInNamedList  \\
\hspace{1cm} W. a sp. mat. of complex doubles in a named list. \\
\hline
\hline
Read/Write sparse boolean matrices in lists \\
\hline
getBooleanSparseMatrixInList  \\
\hspace{1cm} R. a sp. mat. of booleans in a list. \\
readBooleanSparseMatrixInNamedList  \\
\hspace{1cm} R. a sp. mat. of booleans in a named list. \\
createBooleanSparseMatrixInList  \\
\hspace{1cm} W. a sp. mat. of booleans in a list. \\
createBooleanSparseMatrixInNamedList  \\
\hspace{1cm} W. a sp. mat. of booleans in a named list. \\
\hline
\end{tabular}
\end{center}
\caption{The sparse API to read/write in lists.}
\label{fig-scisparse-sciapiLists}
\end{small}
\end{figure}

The following \scifun{read\_sparse} function is a sample example of some of the 
functions which may be used in gateways which manage sparse matrices. 
This example is extracted from the help pages of Scilab. 

The \scifun{read\_sparse} function takes a sparse matrix of doubles as input 
argument and prints its content in the console. 
The sparse matrix may be real or complex, which is taked into account in the 
gateway, based on the output of the \scifun{isVarComplex} function. 
If the matrix is complex, we call the \scifun{getComplexSparseMatrix}, which 
sets the data structures of the sparse matrix. 
The data structures associated with sparse matrices are presented in 
the section \ref{section-storageformat}:
\begin{itemize}
\item \scivar{iRows} : the number of rows, 
\item \scivar{iCols} : the number of columns, 
\item \scivar{iNbItem}: the number of nonzero entries,
\item \scivar{piNbItemRow}:  the number of nonzeros on each row,
\item \scivar{piColPos}:  the column index of each nonzero entry,
\item \scivar{pdblReal}:  the real part of the nonzero entry,
\item \scivar{pdblImg}:  the imaginary part of the nonzero entry.
\end{itemize}
The \scifun{getSparseMatrix} function has the same effect on real matrices, but 
only the \scivar{pdblReal} array is set.
\lstset{language=scilabscript}
\begin{lstlisting}
int read_sparse(char *fname,unsigned long fname_len)
{
   SciErr sciErr;
   int i,j,k;
   int* piAddr         = NULL;
   int iRows         = 0;
   int iCols         = 0;
   int iNbItem         = 0;
   int* piNbItemRow   = NULL;
   int* piColPos      = NULL;
   double* pdblReal   = NULL;
   double* pdblImg      = NULL;
   CheckRhs(1,1);
   sciErr = getVarAddressFromPosition(pvApiCtx, 1, &piAddr);
   if(sciErr.iErr)
   {
      printError(&sciErr, 0);
      return 0;
   }
   if(isVarComplex(pvApiCtx, piAddr))
   {
      sciErr = getComplexSparseMatrix(pvApiCtx, 
         piAddr, &iRows, &iCols, &iNbItem, &piNbItemRow, 
         &piColPos, &pdblReal, &pdblImg);
   }
   else
   {
      sciErr = getSparseMatrix(pvApiCtx, piAddr, 
          &iRows, &iCols, &iNbItem, 
          &piNbItemRow, &piColPos, &pdblReal);
   }
   if(sciErr.iErr)
   {
      printError(&sciErr, 0);
      return 0;
   }
   sciprint("Sparse %d item(s)\n", iNbItem);
   k = 0;
   for(i = 0 ; i < iRows ; i++)
   {
      for(j = 0 ; j < piNbItemRow[i] ; j++)
      {
         sciprint("(%d,%d) = %f", 
            i+1, piColPos[k], pdblReal[k]);
         if(isVarComplex(pvApiCtx, piAddr))
         {
            sciprint(" %+fi", pdblImg[k]);
         }
         sciprint("\n");
         k++;
      }
   }
   LhsVar(1) = 0;
   return 0;
}
\end{lstlisting}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{The ARnoldi PACKage}

ARPACK is a collection of Fortran77 subroutines designed to solve large scale eigenvalue problems.
The functions available in Scilab are presented in the figure \ref{fig-scisparse-arnoldi}.

The package is designed to compute a few eigenvalues and corresponding 
eigenvectors of a general $n$ by $n$ matrix $A$. It is most appropriate for 
large sparse or structured matrices A where structured means that a 
matrix-vector product $w = Av$ requires order $n$ rather than the usual 
order $n^2$ floating point operations. This software is based upon an 
algorithmic variant of the Arnoldi process called the Implicitly 
Restarted Arnoldi Method (IRAM). When the matrix A is symmetric it 
reduces to a variant of the Lanczos process called the Implicitly 
Restarted Lanczos Method (IRLM). These variants may be viewed as a 
synthesis of the Arnoldi/Lanczos process with the Implicitly Shifted QR 
technique that is suitable for large scale problems. For many standard 
problems, a matrix factorization is not required. Only the action of the 
matrix on a vector is needed.

ARPACK software is capable of solving large scale symmetric, 
nonsymmetric, and generalized eigenproblems from significant application 
areas. The software is designed to compute a few ($k$) eigenvalues with 
user specified features such as those of largest real part or largest 
magnitude. Storage requirements are on the order of $nk$ locations. No 
auxiliary storage is required. A set of Schur basis vectors for the 
desired $k$-dimensional eigen-space is computed which is numerically 
orthogonal to working precision. Numerically accurate eigenvectors are 
available on request.

The following is a list of the main features of the library:
\begin{itemize}
\item Reverse Communication Interface.
\item Single and Double Precision Real Arithmetic Versions for Symmetric, Non-symmetric,
\item Standard or Generalized Problems.
\item Single and Double Precision Complex Arithmetic Versions for Standard or Generalized Problems.
\item Routines for Banded Matrices - Standard or Generalized Problems.
\item Routines for The Singular Value Decomposition.
\item Example driver routines that may be used as templates to implement numerous Shift-Invert strategies for all problem types, data types and precision.
\end{itemize}

\begin{figure}
\begin{center}
\begin{tabular}{|ll|}
\hline
dnaupd &  compute approximations to a few eigenpairs of \\
       & a real linear operator \\
dneupd &  compute the converged approximations to eigenvalues \\
       & of $Az = \lambda B z$, approximations to a few eigenpairs \\
       & of a real linear operator \\
dsaupd &  compute approximations to a few eigenpairs of a real and \\
       &  symmetric linear operator \\
dsaupd &  compute approximations to the converged approximations to \\
       &  eigenvalues of $Az = \lambda B z$ \\
znaupd &  compute a few eigenpairs of a complex linear operator \\
       & with respect to a semi-inner product defined by a \\
       & hermitian positive semi-definite real matrix $B$. \\
zneupd &  compute approximations to the converged approximations to \\
       &  eigenvalues of $Az = \lambda B z$ \\
\hline
\end{tabular}
\end{center}
\caption{Functions from the Arnoldi Package.}
\label{fig-scisparse-arnoldi}
\end{figure}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\section{The Matrix Market module}

The Matrix Market (MM) exchange formats provide a simple mechanism to 
facilitate the exchange of matrix data. In particular, the objective has 
been to define a minimal base ASCII file format which can be very easily 
explained and parsed, but can easily adapted to applications with a more 
rigid structure, or extended to related data objects. The MM exchange 
format for matrices is really a collection of affiliated formats which 
share design elements.

In the specification, two matrix formats are defined.
\begin{itemize}
\item Coordinate Format. 
A file format suitable for representing general sparse matrices. Only 
nonzero entries are provided, and the coordinates of each nonzero entry 
is given explicitly. This is illustrated in the example below.
\item Array Format.
A file format suitable for representing general dense matrices. All 
entries are provided in a pre-defined (column-oriented) order.
\end{itemize}

The Matrix Market file format can be used to manage dense or sparse matrices.
MM coordinate format is suitable for representing sparse matrices. Only 
nonzero entries need be encoded, and the coordinates of each are given 
explicitly. 

\begin{center}
\url{http://atoms.scilab.org/toolboxes/MatrixMarket}
\end{center}

In order to install the Matrix Market module, we use the atoms system,
as in the following script.
\lstset{language=scilabscript}
\begin{lstlisting}
atomsInstall("MatrixMarket")
\end{lstlisting}


The table \ref{fig-scisparse-mmmodule} presents the functions provided 
by the Matrix Market module.

\begin{figure}
\begin{center}
\begin{tabular}{|ll|}
\hline
mminfo & Extracts size and storage information \\
mmread & Reads a Matrix Market file  \\
mmwrite & Writes a sparse or dense matrix \\
\hline
\end{tabular}
\end{center}
\caption{Functions from the Matrix Market module.}
\label{fig-scisparse-mmmodule}
\end{figure}


In the following script, we create a sparse matrix with the \scifun{sparse}
function and save it into a file with the \scifun{mmwrite} function.
\lstset{language=scilabscript}
\begin{lstlisting}
A=sparse([1,1;1,3;2,2;3,1;3,3;3,4;4,3;4,4],..
  [9;27+%i;16;27-%i;145;88;88;121],[4,4]) ;
filename = TMPDIR+"/A.mtx";
mmwrite(filename,A);
\end{lstlisting}
In the following session, we use the \scifun{mminfo} function to extract informations
from this file.
\lstset{language=scilabscript}
\begin{lstlisting}
-->mminfo(filename);
=====================================
Information about MatrixMarket file :
C:\Users\myname\AppData\Local\Temp\SCI_TMP_8216_/A.mtx
%%% Generated by Scilab 11-Jun-2010
storage: coordinate
entry type: complex
symmetry: hermitian
=====================================
\end{lstlisting}
In the following session, we use another calling sequence of the \scifun{mminfo}
function to extract data from the file. This allows to get the number of 
rows \scivar{rows}, the number of columns \scivar{cols}, the number 
of entries and other informations as well.
\lstset{language=scilabscript}
\begin{lstlisting}
-->[rows,cols,entries,rep,field,symm,comm] = mminfo(filename)
 comm  =
 %%% Generated by Scilab 11-Jun-2010   
 symm  =
 hermitian   
 field  =
 complex   
 rep  =
 coordinate   
 entries  =
    6.  
 cols  =
    4.  
 rows  =
    4.  
\end{lstlisting}
In the following session, we use the \scifun{mmread} function to read the content 
of the file and create the matrix \scivar{A}. We use the 
\scifun{nnz} function to compute the number of nonzero entries in the 
matrix.
\lstset{language=scilabscript}
\begin{lstlisting}
-->A=mmread(filename)
 A  =
(    4,    4) sparse matrix
(    1,    1)       9. 
(    1,    3)       27. + 1.i 
(    2,    2)       16. 
(    3,    1)       27. - 1.i 
(    3,    3)       145. 
(    3,    4)       88. 
(    4,    3)       88. 
(    4,    4)       121. 
 -->nnz(A)
 ans  =
    8.  
\end{lstlisting}



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\section{Solving Poisson PDE with Sparse Matrices}

In this section, we present the resolution of the Poisson Partial Differential Equation 
in Scilab with sparse matrices. 
We show that Scilab 5 can solve in a few seconds sparse linear systems of 
equations with as many as 250 000 unknowns because Scilab only store nonzero entries. 
The computations are based on the Scibench module, a toolbox which provides 
a collection of benchmarks for Scilab. 
This section was first published at \cite{wikiPoissonPDE}.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection{Introduction}

Sharma and Gobbert analyzed the performance of Scilab for the resolution of 
sparse linear systems of equations associated with the Poisson equation \cite{Sharmar2010}. 
In this document, we try to reproduce their experiments.

We consider the Poisson problem with homogeneous Dirichlet boundary 
conditions and are interested in the numerical solution based on 
finite differences.

We consider the 2 dimensional Partial Differential Equation:

$$\begin{array}{rlll}
- \Delta u &=& f &\textrm{ in the domain,} \\
u &=& 0 &\textrm{ on the frontier.} 
\end{array}$$
 
where the two dimensionnal Laplace operator is

$$
\Delta u = \frac{\partial^2 u}{dx^2} + \frac{\partial^2 u}{dy^2}
$$

We consider the domain $0 \leq x \leq 1$, $0 \leq y \leq 1$.

The function f is defined by 
$$
f(x, y) = -2\pi^2 cos(2\pi x) sin^2(\pi y) - 2\pi^2 sin^2(\pi x) cos(2\pi y) 
$$

The solution is 
$$u(x, y) = sin^2(\pi x) sin^2(\pi y)$$

We use a second order finite difference approximation of 
the Laplace operator based on a grid of N-by-N points. 

Sparse matrices can be managed in Scilab since 1989 \cite{Basile1989}. 
In Scilab 5.0 (i.e. in 2008), the UMFPACK module was added. 

The Scibench external module:
\begin{center}
\url{http://atoms.scilab.org/toolboxes/scibench}
\end{center}

provides a collection of benchmark scripts to measure the performance of Scilab.
For example, it contains benchmarks for the dense matrix-matrix product, 
the dense backslash operator, the Cholesky decomposition or 2D Lattice Boltzmann simulations. 

In order to install this module, we use the statement:
\lstset{language=scilabscript}
\begin{lstlisting}
atomsInstall("scibench")
\end{lstlisting}
and restart Scilab.

The version 0.6 includes benchmarks for sparse matrices, 
based on the Poisson equation. 
The performance presented in this document are measured with Scilab 5.3.2 on 
Windows XP with a 4GB computer using Intel Xeon E5410 4*2.33 GHz processors.

The script that we are going to use is \scivar{poisson.sce}, which is 
provided in the demos directory of the module.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection{The sparse matrix}

The \scifun{scibench\_poissonA(n)} statement creates a sparse matrix equation 
associated with n cells in the X coordinate and n cells in the Y coordinate. 
Before calling this session, we call the stacksize function in order to let 
Scilab allocate as much memory as possible. 
Then we call the \scifun{PlotSparse} function to plot the sparsity pattern of the matrix.
\lstset{language=scilabscript}
\begin{lstlisting}
stacksize("max");
A = scibench_poissonA(50);
PlotSparse(A)
\end{lstlisting}

The previous script produces the plot in the figure \ref{fig-sparsityPoisson}.

\begin{figure}
\begin{center}
\includegraphics[width=10cm]{PoissonSparsityPattern}
\end{center}
\caption{Sparsity pattern of the Poisson matrix.}
\label{fig-sparsityPoisson}
\end{figure}

We emphasize that the previous matrix is a $n^2$-by-$n^2$ sparse matrix. 
Even for moderate values of n, this creates huge matrices. 
Fortunately, only nonzero entries are stored, so that Scilab 
has no problem to store it, provided that the nonzero entries can be stored in the memory.
\lstset{language=scilabscript}
\begin{lstlisting}
-->size(A)
 ans  =
    2500.    2500.  
\end{lstlisting}

The Kronecker operator is used, so that the computation of the matrix is vectorized. 
To edit the code, we just run the following code.
\lstset{language=scilabscript}
\begin{lstlisting}
-->edit scibench_poissonA
\end{lstlisting}
At the core of the algorithm, we find the statement
\lstset{language=scilabscript}
\begin{lstlisting}
A = I .*. T + T .*. I
\end{lstlisting}
where T is a sparse matrix and I is the sparse n-by-n identity matrix.
Hence, creating the whole matrix is done with only one statement.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection{The Poisson Solver}

The \scifun{scibench\_poisson}  function solves the 2D Poisson equation. 
Its calling sequence is 
\lstset{language=scilabscript}
\begin{lstlisting}
scibench_poisson ( N , plotgraph , verbose , solver )
\end{lstlisting}
where \scivar{N} is the number of cells, \scivar{plotgraph} is a boolean to plot the graphics, 
\scivar{verbose} is a boolean to print messages and solver is a function 
which solves the linear equation \scivar{A*x=b}.

The solver argument is designed so that we can customize the 
linear equation solver which we want to use. 
For example, if we want to use the sparse backslash operator, 
all we have to do is to create the \scivar{mysolverBackslash} function as below.
\lstset{language=scilabscript}
\begin{lstlisting}
function u=mysolverBackslash(N, b)
    A = scibench_poissonA(N);
    u = A\b;
endfunction
\end{lstlisting}

The following script solves the Poisson equation with N = 50.
\lstset{language=scilabscript}
\begin{lstlisting}
scf();
scibench_poisson(50, %t , %t , mysolverBackslash );
\end{lstlisting}
The previous script produces the following output, where \scivar{h} is 
the dimensionnal spacee step and enorminf is the value of the 
infinite norm of the error.
\lstset{language=scilabscript}
\begin{lstlisting}
->scibench_poisson(50, %t , %t , mysolverBackslash );
N =    50
h =  1.9607843137254902e-002
h^2 =  3.8446751249519417e-004
enorminf =  1.2634082165868810e-003
C = enorminf / h^2 =  3.2861247713424775e+000
wall clock time =       0.15 seconds
\end{lstlisting}

The previous script also produces the plot in the 
figure \ref{fig-poissonapproxsol}.

\begin{figure}
\begin{center}
\includegraphics[width=10cm]{plotSolutionPoisson}
\end{center}
\caption{Approximate solution and numerical error of the Poisson equation.}
\label{fig-poissonapproxsol}
\end{figure}

It is then easy to use the pcg function built in Scilab, which uses a 
pre-conditionned conjugate gradient algorithm. 
We use the \scifun{scibench\_poissonAu} function, which 
computes the \scivar{A*u} product without actually storing the matrix A.
\lstset{language=scilabscript}
\begin{lstlisting}
function u=mysolverPCG(N, b)
    tol = 0.000001;
    maxit = 9999;
    u = zeros(N^2,1);
    [u,flag,iter,res] = ..
	    pcg(scibench_poissonAu,b,tol,maxit,[],[],u);
endfunction
scf();
[timesec,enorminf,h] = ..
    scibench_poisson(50, %f , %t , mysolverPCG );
\end{lstlisting}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection{The benchmark}

Based on the scibench module, it is easy to compare various sparse 
linear equation solvers in Scilab. 
We compared the following functions:
\begin{itemize}
\item sparse backslash (which internally use a sparse LU decomposition),
\item \scifun{pcg} function,
\item \scifun{UMPFACK} module,
\item the \scifun{TAUCS} module.
\end{itemize}

Both the UMFPACK and TAUCS modules were created by Bruno Pincon \cite{Pincon2004}.

In order to use the UMFPACK module, we created the 
following \scifun{mysolverUMF} function which solves the A*u=b equation.
\lstset{language=scilabscript}
\begin{lstlisting}
function u = mysolverUMF(N,b)
    A = scibench_poissonA(N);
    humf = umf_lufact(A);
    u = umf_lusolve(humf,b)
    umf_ludel(humf)
endfunction
\end{lstlisting}
We also created the following wrapper for the TAUCS module.
\lstset{language=scilabscript}
\begin{lstlisting}
function u = mysolverTAUCS(N,b)
    A = scibench_poissonA(N);
    hchol = taucs_chfact(A);
    u = taucs_chsolve(hchol,b)
    taucs_chdel(hchol)
endfunction
\end{lstlisting}

We were unable to use the TAUCS solver, which makes Scilab unstable in this case. 
This problem was reported in the following bug report:
\begin{center}
\url{http://bugzilla.scilab.org/show_bug.cgi?id=8824}
\end{center}

It is straightforward to created increasingly large matrices and 
to measure the time required to solve the Poisson equation. 
The script is provided within the demos of the scibench module. 
The plot in the figure \ref{fig-poissoncomparison} compares the various solvers.

\begin{figure}
\begin{center}
\includegraphics[width=13cm]{comparisonSolvers}
\end{center}
\caption{Comparison of solvers for the sparse linear system of equations of the Poisson equation.}
\label{fig-poissoncomparison}
\end{figure}

It is obvious that, in this case, the UMFPACK module is much faster. 

The fact that we use the pcg function without actually preconditionning 
the matrix is an obvious limitation of this benchmark. 
This is why we work on updating the sparse ILU preconditionners in the following Forge project:
\begin{center}
\url{http://forge.scilab.org/index.php/p/spilu/}
\end{center}

The current work is based on the former Scilin project.

This benchmark shows that we can solve really large systems of equations. 
The table in the figure \ref{fig-poissbenchtab} displays the performance measures.

\begin{figure}
\begin{center}
\begin{tabular}{|l|l|l|l|}
\hline
\textbf{Solver}    & \textbf{N}   & \textbf{Matrix Size}      & \textbf{Time (s)} \\
\hline
Backslash & 50  & 2500-by-2500     & 0.15   \\
PCG       & 50  & 2500-by-2500     & 0.09    \\
Backslash & 100 & 10000-by-10000   & 4.32    \\
PCG       & 100 & 10000-by-10000   & 0.32    \\
Backslash & 200 & 40000-by-40000   & 88.89   \\
PCG       & 200 & 40000-by-40000   & 2.03    \\
UMFPACK   & 200 & 40000-by-40000   & 0.81    \\
PCG       & 300 & 90000-by-90000   & 7.27     \\
UMFPACK   & 300 & 90000-by-90000   & 2.35     \\
PCG       & 500 & 250000-by-250000 & 44.77    \\
\hline
\end{tabular}
\end{center}
\caption{The Poisson benchmark for various size of matrices.}
\label{fig-poissbenchtab}
\end{figure}

For matrices larger than approximately 400, the UMFPACK functions 
fails to solve the equation because they require more memory than 
Scilab can provide to it.
\lstset{language=scilabscript}
\begin{lstlisting}
--> scibench_poisson(400, %t , %t , mysolverUMF )
 !--error 999 
umf_lufact: An error occurred: 
  symbolic factorization: not enough memory
at line       3 of function mysolverUMF called by :  
at line      95 of function scibench_poisson called by :  
 scibench_poisson(400, %t , %t , mysolverUMF )
\end{lstlisting}

We emphasize that the actual size of the matrix does not matter. 
What matters is the number of nonzero terms in the matrix. 
For example, with N=500, the matrix is  250000-by-250000 but 
has only 1 248 000 nonzero entries.
\lstset{language=scilabscript}
\begin{lstlisting}
-->A = scibench_poissonA ( 500 );
-->size(A)
 ans  =
    250000.    250000.  
-->nnz(A)
 ans  =
    1248000.  
\end{lstlisting}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection{Conclusion}

Scilab 5 can manage sparse matrices and solve partial differential 
equations such as the Poisson equation for example. 
Indeed, Scilab provides several sparse linear equation solvers, 
including a sparse backslash operator, iterative methods (e.g. the 
pre-conditionned conjugate gradient algorithm) and other direct 
solvers such as the UMFPACK or TAUCS modules. 
With these tools we can solve huge systems of linear equations, 
because Scilab only stores the nonzero entries of these massive matrices. 
The solvers may fail if the memory required to store the matrix is 
beyond the capacity of Scilab, but this happens only for huge matrices. 
In this case, the future Scilab 6 may help to overcome this limitation, 
by removing the use of the stack which is used 
by Scilab 5 (see \cite{BaudinProgSci2011} for more details on this topic). 
Another limitation of Scilab is that there is currently no 
preconditionner for sparse linear systems of equations. 
This limitation should be removed once the \emph{spilu} module is ready for a release.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{The Imsls toolbox}

The Imsls toolbox provides iterative methods for sparse linear systems 
of equations.

More precisely, it provides functions to find $x$ such that $Ax=b$, 
where $A$ is a n-by-n matrix of doubles and $b$ is a n-by-1 matrix of doubles. 
Although these functions can manage full matrices, it is mainly 
designed for sparse matrices.
One of the interesting point here is that the matrix-vector 
products or the preconditionning steps \scivar{M\textbackslash x} can be 
performed either with full or sparse matrices, or with callback functions. 
This flexibility makes the module convenient to use in situations when the 
sparse matrices are not stored in memory, since only the matrix-vector 
product (or the preconditionning step \scivar{M\textbackslash x}) is required.
Moreover, we provide Matlab-compatible pcg, gmres and qmr solvers:
\begin{itemize}
\item the order of the arguments are the same as in Matlab,
\item the default values of the Matlab functions are the same as in Matlab,
\item the headers of the callback functions are the same as in Matlab.
\end{itemize}
This contrasts with Scilab's internal functions, where the two last points 
are completely unsatisfied.
Finally, we provide a complete test suite for these functions, which are 
using robust argument checking.

The main functions are presented in the figure \ref{fig-imslsmain}. 

\begin{figure}
\begin{center}
\begin{tabular}{|ll|}
\hline
imsls\_bicg &  BIConjugate Gradient method \\
imsls\_bicgstab &  BIConjugate Gradient STABilized method \\
imsls\_pcg &  Conjugate Gradient method \\
imsls\_cgs &  Conjugate Gradient Squared method \\
imsls\_cheby &  CHEBYshev method \\
imsls\_gmres &  Generalized Minimal RESidual method \\
imsls\_jacobi &  JACOBI method \\
imsls\_qmr &  Quasi Minimal Residual method \\
imsls\_sor &  Successive Over-Relaxation method \\
\hline
\end{tabular}
\end{center}
\caption{Main functions in the Imsls toolbox.}
\label{fig-imslsmain}
\end{figure}

The Imsls toolbox also provides Matlab compatibility functions, which 
are presented in the figure \ref{fig-imslscompat}.

\begin{figure}
\begin{center}
\begin{tabular}{|ll|}
\hline
mtlb\_bicg & BiConjugate Gradient method \\
mtlb\_bicgstab & BiConjugate Gradient Stabilized method \\
mtlb\_cgs & Conjugate Gradient Squared method \\
mtlb\_gmres & Generalized Minimal residual method \\
mtlb\_pcg & Conjugate Gradient method \\
mtlb\_qmr & Quasi Minimal Residual method \\
\hline
\end{tabular}
\end{center}
\caption{Compatibility functions in the Imsls toolbox.}
\label{fig-imslscompat}
\end{figure}

The \scifun{imsls\_gmres} function finds $x$ such that $Ax=b$. 
In the following script, we create a 16-by-16 matrix of doubles. 
Although this matrix is symmetric, the \scivar{imsls\_gmres} function 
can manage nonsymmetric matrices. 
Then we define the expected result \scivar{xe}, and compute the right 
hand side \scivar{b}. 
Finally, we call the \scivar{imsls\_gmres}, which returns \scivar{x}.
\lstset{language=scilabscript}
\begin{lstlisting}
A=imsls_makefish(4);
xe=(1:16)';
b=A*xe;
x = imsls_gmres(A,b)
\end{lstlisting}
The previous script produces the following output.
\lstset{language=scilabscript}
\begin{lstlisting}
-->x = imsls_gmres(A,b)
 x  =
    1.   
    2.   
    3.   
    4.   
    5.   
    6.   
    7.   
    8.   
    9.   
   10.   
    11.  
    12.  
    13.  
    14.  
    15.  
    16.
\end{lstlisting}

The Imsls toolbox is available on Atoms:
\begin{center}
\url{http://atoms.scilab.org/toolboxes/imsls}
\end{center}
To install this module, we can use the statement
\lstset{language=scilabscript}
\begin{lstlisting}
atomsInstall("imsls")
\end{lstlisting}
and restart Scilab.

